import React, { PureComponent } from "react";
import { connect } from "dva";
import { message, Slider } from "antd";
import styles from "./index.less";
import { presetDarkPalettes } from "@ant-design/colors";

let clear = null;
let aa = 1;
let reca=220;
let iTime;
class FontColor extends PureComponent {

  state={
    fontlength:0,
    bot:false,
    orios:false
  }
  closemodal = () => {
    const { dispatch } = this.props;
    dispatch({
      type: "edit/changecolorflag",
      payload: {
        color_flag: false,
      },
    });
    aa = 1;
  };

  changshju = () => {
    const {
      dispatch,
      editModel: { recadTextModalItem, reacdTextIndex, fontcolorchange ,countFlagApply},
    } = this.props;
    let obj = { ...recadTextModalItem };
    obj.fontSetting = { ...obj.fontSetting, ...fontcolorchange };
    console.log(obj);
    dispatch({
      type: "edit/handleTextChangeItem",
      payload: {
        index: reacdTextIndex,
        obj: obj,
        countFlagApply:countFlagApply+1
      },
    });
    dispatch({
      type: "edit/changecolorflag",
      payload: {
        color_flag: false,
      },
    });
    aa = 1;
  };

  log = name => {
    return value => {
      const {
        dispatch
      } = this.props;
      aa++;
      dispatch({
        type: "edit/chaneWordColor",
        payload: {
          nameKey:'strokeWidth',
          strokeWidth:value
        },
      });
    };
  };

  renderFontColor = (style, fun) => {
    const colorKey = Object.keys(presetDarkPalettes);
    let colorArray = [];
    colorKey.map((item, k) => {
      colorArray = [...colorArray, ...presetDarkPalettes[item]];
      return colorArray;
    });
    const color_dom = colorArray.map(item => {
      return (
        <div className={style} key={item} onClick={(e)=>fun(e,item)} style={{ background: `${item}` }}></div>
      );
    });
    return color_dom;
  };

  wenbenClick = () => {
    const {
      editModel: { txtNum },
      dispatch,
    } = this.props;
    const change_color = this.refs.yanseDiv;
    const yanse = this.refs.yanse;
    const wenben = this.refs.wenben;
    const textareaText=this.refs.textareaText
    textareaText.style.display='block'
    change_color.style.display = "none";
    yanse.classList.remove(`${styles.activeColor}`);
    wenben.classList.add(`${styles.activeColor}`);
    let textarea = this.refs.textareaChange;
    if (textarea) {
      textarea.focus();
    }
    dispatch({
      type: "edit/wenbenClick",
      payload: {
        txtNum: txtNum + 1,
      },
    });
    aa ++;
    this.setState({
      bot:false
    })
  };
  blurChangeText = e => {
    const {
      dispatch,
      editModel: { fontcolorchange },
    } = this.props;
    let obj = { ...fontcolorchange };
    obj.defaultText = e.target.value;
    dispatch({
      type: "edit/recadTextModal",
      payload: {
        fontcolorchange: obj,
      },
    });
    // dispatch({
    //   type: "edit/save",
    //   payload: {
    //     color_flag: false,
    //   },
    // })
  };
  yanseClick = () => {
    const {dispatch}=this.props
    const change_color = this.refs.yanseDiv;
    const yanse = this.refs.yanse;
    const  wenben = this.refs.wenben;
    const textareaText=this.refs.textareaText
    document.activeElement.blur()
    textareaText.style.display='none'
    dispatch({
      type:'edit/recakeybrop',
      payload:{
        keyboardStyle:0
      }
    })
    this.setState({
      bot:true
    })
    // let textarea = this.refs.textareaChange;
    // textarea.blur()
    clearTimeout(iTime);
        iTime = setTimeout(function () {
        change_color.style.display = "block";
    }, 550);
    wenben.classList.remove(`${styles.activeColor}`);
    yanse.classList.add(`${styles.activeColor}`);
    // change_color.style.display = "block";
    clearTimeout(clear);
    aa++
  };
  pickOut = (e,item) => {
    clearTimeout(clear);
    aa++;
    let colorLump = document.getElementsByClassName(`${styles.colorLump}`);
    for (let i = 0; i < colorLump.length; i++) {
      const element = colorLump[i];
      element.style.border = "2px solid #fff";
    }
    e.target.style.border = "2px solid #607fff";
    const {dispatch} = this.props;
    dispatch({
      type: "edit/chaneWordColor",
      payload: {
        nameKey:'textColor',
        textColor:item
      },
    });
    clearTimeout(clear);  
  };
  pickTrace = (e,item) => {
    aa++;
    clearTimeout(clear);
    let traceColor = document.getElementsByClassName(`${styles.traceColor}`);
    for (let i = 0; i < traceColor.length; i++) {
      const element = traceColor[i];
      element.style.border = "2px solid #fff";
    }
    e.target.style.border = "2px solid #607fff";
    const {dispatch} = this.props;
    dispatch({
      type: "edit/chaneWordColor",
      payload: {
        nameKey:'strokeColor',
        strokeColor:item
      },
    });
    clearTimeout(clear);
  };
  closeflag = e => {
    // let textarea = this.refs.textareaChange;
    // textarea.focus()
    // e.stopPropagation();
  };
  changeblurText=(e)=>{
    const {
      dispatch,
      editModel: { fontcolorchange },
    } = this.props;
    let text = fontcolorchange;
    this.setState({
      fontlength:e.target.value.length
    })
    text.defaultText = e.target.value;
    dispatch({
      type: "edit/chaneWordColor",
      payload: {
        nameKey:'defaultText',
        defaultText:e.target.value
      },
    });
  }
  textFocus=(e)=>{
    e.target.selectionStart=e.target.value.length
    var u = navigator.userAgent, app = navigator.appVersion;
    var isAndroid = u.indexOf('Android') > -1 || u.indexOf('Linux') > -1; // Android
    var isIOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); 
   var isXiaomi = u.indexOf('XiaoMi') > -1
    if(isAndroid){
      if(isXiaomi){
        this.setState({
          orios:true
        })
      }else{
        this.setState({
          orios:false
        })
      }
    }
    if(isIOS){
      this.setState({
        orios:true
      })
    }
    // message.info(e.detail.height);
    // console.log(e.target.forScroll)
    // document.documentElement.scrollTop=0;
    this.setState({
      fontlength:e.target.value.length
    })
    let yanseDiv=this.refs.yanseDiv
    yanseDiv.style.display='none'
    reca=220
    const yanse = this.refs.yanse;
    const wenben = this.refs.wenben;
    yanse.classList.remove(`${styles.activeColor}`);
    wenben.classList.add(`${styles.activeColor}`);
  }
  rendertextarea = () => {
    const {
      editModel: { groups,check, reacdTextIndex},
    } = this.props;
    const {
        defaultText
      } = groups[check].allMaterial[reacdTextIndex].fontSetting,
      // textAligns = {
      //   0: "left",
      //   1: "right",
      //   2: "center",
      // },
      textareaStyle = {
        resize: "none",
        color: 'black'
      };
    return (
      <textarea
        ref="textareaChange"
        // autofocus="autofocus"
        name=""
        id=""
        cols="10"
        rows="1"
        defaultValue={defaultText}
        style={textareaStyle}
        className={styles.zhe_text}
        onBlur={this.blurChangeText}
        onChange={this.changeblurText}
        onFocus={this.textFocus}
      ></textarea>
    );
  };

  render() {
    const { renderFontColor, rendertextarea } = this;
    const { fontlength ,bot,orios} = this.state;
    const {
      editModel: { color_flag,keyboardStyle }
    } = this.props;
    if (color_flag === true) {
      clear = setTimeout(() => {
        let textarea = this.refs.textareaChange;
        if (textarea) {
          textarea.focus();
        }
      }, 0);
    }
    document.body.addEventListener('focusout', () => { //软键盘关闭事件
      // message.info(1)
      //  this.setState({
      //   orios:false
      //  })
       document.activeElement.blur()
    })
    return ( //style={{bottom:`${orios?bot?0:160:0}px`}}
      <div className={styles.fontCon}  onClick={this.closeflag}>
        <div>
          <div className={styles.nav}>
          {/* style={{bottom:`${keyboardStyle>0?reca:0}px`}}  style={{bottom:`${keyboardStyle>0?reca:0}px`}}*/}
            <span className={styles.activeColor} ref="wenben" onClick={this.wenbenClick}>
              文本
            </span>
            <span ref="yanse" onClick={this.yanseClick}>
              颜色
            </span>
          </div>
          <div className={styles.yanseDiv} ref="yanseDiv">
            <div className={styles.center}>
              <span className={styles.fontControl}>字体颜色</span>
              <div className={styles.fontColor}>
                {renderFontColor(styles.colorLump, this.pickOut)}
              </div>
            </div>
            <div className={styles.center}>
              <span className={styles.fontControl}>描边颜色</span>
              <div className={styles.fontColor}>
                {renderFontColor(styles.traceColor, this.pickTrace)}
              </div>
            </div>
            <div className={styles.center}>
              <span className={styles.fontControl}>描边粗细</span>
              {/* <div className="fontColor"> */}
              <div
                style={{ width: "70%", lineHeight: "36px", marginTop: "0px", marginLeft: "-15px" }}
              >
                <Slider
                  style={{ marginLeft: 30, marginRight: 30, touchAction: "none" }}
                  defaultValue={0}
                  min={0}
                  max={10}
                  tipFormatter={null}
                  onChange={this.log('change')}
                  // onAfterChange={this.log("afterChange")}
                />
              </div>
            </div>
            {/* </div> */}
          </div>
          <div className={styles.zitiDiv} ref='textareaText'>
            <div className={styles.text_sty}>
              {rendertextarea()}<div className={styles.text_length}>{fontlength}/1000</div>
            </div>
            {/* {orios?(<div style={{height:'50px',background:'#fff'}}></div>):null} */}
          </div>
        </div>
      </div>
    );
  }
}
const stateToProps = state => ({
  editModel: state["edit"],
});

export default connect(stateToProps)(FontColor);
