// pages/index/index.js
let app = getApp()
Page({
  /**
   * 页面的初始数据
   */
  data: {
    list: [],
    pageNum: 1,
    token: '',
  },

  onLoad() {
    let _this = this
    // wx.request({
    //   url: app.hostUrl + '/demo/public/gen_token',
    //   method: 'POST',
    //   header: {
    //     'content-type': 'application/x-www-form-urlencoded',
    //   },
    //   success: function (res) {
    //     _this.data.token = res.data.data.token
    //     let obj = {};
    //     obj.token = res.data.data.token;
    //     obj.source_url = res.data.data.source_url
    //     wx.setStorageSync(
    //       'token', obj
    //     )

    //   }
    // })
    _this.getNoticeList()
  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    this.onBottom()
  },

  onBottom() {
    this.data.pageNum++
    this.getNoticeList('')
  },
  getNoticeList() {
    let { token } = this.data
    let _this = this
    let pageNo = this.data.pageNum
    wx.request({
      url: app.hostUrl + '/TemplateDemo.php',
      method: 'POST',
      header: {
        'content-type': 'application/json',
        'login-token': token,
      },
      data: {
        applet: 1,
        page: pageNo,
      },
      success: function (res) {
        if (pageNo == 1) {
          _this.setData({
            list: res.data.data.list,
          })
        } else {
          let noticeList = _this.data.list
          let arr = res.data.data.list
          let newArr = noticeList.concat(arr)
          _this.setData({
            list: newArr,
          })
        }
      },
    })
  },

  makeTap(e) {
    const { item } = e.currentTarget.dataset
    wx.navigateTo({
      url: '../make/make?item=' + JSON.stringify(item),
    })
  },
})
