import React, { PureComponent } from "react";
import { connect } from "dva";
import styles from "./index.less";
import { Icon } from "antd";
import { Button } from 'antd';
import router from "umi/router";

class PageHead extends PureComponent {
  goback = () => {
    window.history.back(-1);
  };
  next=()=>{
    // const {location,handleOnOK} = this.props
    // this.props.handleOnOK()
    router.push({
      pathname: "/compile",
      // query: {
      //   ...location.query
      // },
    });
  }
  render() {
    const { page ,vedionext} = this.props;
    return (
      <div className={styles.pagehead}>
        {Number(page) > 1 ? (
          <Icon type="left" onClick={this.goback} />
        ) : (
          <span style={{ width: "16px" }}></span>
        )}
        {Number(vedionext)>0?<span style={{ marginLeft: "30px" }}>VE</span>:<span style={{ marginLeft: "-15px" }}>VE</span>}
        {Number(vedionext)>0?<Button onClick={this.next} type="link" style={{color:'#595959',fontWeight:'700',padding:'0 0'}}>下一步<Icon style={{color:'#595959',fontWeight:'700'}} type="right" /></Button>:<span></span>}
      </div>
    );
  }
}
const stateToProps = state => ({
  editModel: state["edit"],
});

export default connect(stateToProps)(PageHead);
