// pages/make/make.js
import ParseConfig from '../../utils/ParseConfig'
let app = getApp();
Page({
  data: {
    name: "",
    url: "",
    video: "",
    counter: {},
    all: {},
    config_url: ""

  },
  onLoad: function (options) {

    let _this = this
    let item = JSON.parse(options.item)
    app.all.assetList = JSON.parse(item.asset_list)
    app.all.bgList = JSON.parse(item.bg_list)
    app.all.fgList = JSON.parse(item.fg_list)
    app.all.id = item.id
    this.setData({
      name: item.template_name,
      url: item.template_cover_image,
      video: item.template_demo_video,
      config_url: item.config_url
    })
    let config_url = item.config_url
    wx.request({
      url: config_url,
      method: "get",
      header: {
        'content-type': 'application/json',
      },
      success: function (res) {
        console.log(res);
        console.error(1)
        let json = new ParseConfig(res.data)
        json.getTotalTime();
        _this.setData({
          all: res.data,
          counter: json
        })
      },
      fail(e) {
        console.log(e);
      }
    })
  },
  makeClick(e) {
    let {
      config_url
    } = this.data;
    wx.navigateTo({
      url: '../edit/edit?item=' + config_url,
    })
  }
})